--[[
***********************************************************
** PseudonymousEd, the Dev
** How Much Fuel 41.51
***********************************************************
Copyright 2021 PseudonymousEd

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
--]]

require "TimedActions/ISBaseTimedAction"

HMFCheckFuel = ISBaseTimedAction:derive("HMFCheckFuel");

function HMFCheckFuel:isValid()
	return true;
end

function HMFCheckFuel:waitToStart()
	self.character:faceThisObject(self.pump)
   return self.character:shouldBeTurning()
end

function HMFCheckFuel:update()
	self.character:faceThisObject(self.pump)
end

function HMFCheckFuel:start()
	self:setActionAnim("Loot")
end

function HMFCheckFuel:stop()
	ISBaseTimedAction.stop(self);
end

function HMFCheckFuel:perform()
	self.character:Say(tostring(self.fuelAmount))
	
	-- needed to remove from queue / start next.
	ISBaseTimedAction.perform(self);
end

function HMFCheckFuel:new(character, pump, fuelAmount)
   local o = {}
   setmetatable(o, self)
   self.__index = self
   o.character = character
   o.pump = pump
   o.fuelAmount = fuelAmount;
   o.maxTime = 5
   return o;
end
