--[[
***********************************************************
** PseudonymousEd, the Dev
** How Much Fuel 41.51
***********************************************************
Copyright 2021 PseudonymousEd

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
--]]

HMF = {};

HMF.testcontextmenu = function(_player, context, worldobjects)
    local player = getSpecificPlayer(_player);
    local thisObject = worldobjects[1];

	local thisModData = thisObject:getModData()
	
	local thisSprite = thisObject:getSprite()
	if thisSprite then
		local properties = thisSprite:getProperties()

		if properties ~= nil and properties:Is("fuelAmount") then
			local currentFuelAmount = thisObject:getPipedFuelAmount()

			-- TODO:  Enable Infinite fuel once the Infinite Fuel bug is fixed
			--if SandboxVars.FuelStationGas == 8 then
				--currentFuelAmount = getText(Sandbox_FuelStationGas_option8)
			--	currentFuelAmount = "Infinite!!!"
			--end

			local contextMenu = "ContextMenu_CheckFuelAmount"
			context:addOption(getText(contextMenu),
							  worldobjects,
							  HMF.onCheckFuel,
							  player,
							  thisObject,
							  currentFuelAmount);

		end
	end
end

HMF.onCheckFuel = function(worldobjects, player, thisObject, fuelAmount)
	if luautils.walkAdj(player, thisObject:getSquare()) then
		ISTimedActionQueue.add(HMFCheckFuel:new(player,thisObject,fuelAmount));
	end
end


Events.OnPreFillWorldObjectContextMenu.Add(HMF.testcontextmenu);
